package explorviz.hpc_monitoring.record.events;

import explorviz.hpc_monitoring.record.IRecord;
import explorviz.hpc_monitoring.record.RuntimeStatisticInformation;

public class AbstractOperationEvent implements IRecord {
    private final long                        timestamp;
    private final long                        traceId;
    private final int                         orderIndex;
    private final String                      operationSignature;
    private final RuntimeStatisticInformation runtimeStatisticInformation;

    public AbstractOperationEvent(final long timestamp, final long traceId,
            final int orderIndex, final String operationSignature) {
        super();
        this.timestamp = timestamp;
        this.traceId = traceId;
        this.orderIndex = orderIndex;
        this.operationSignature = operationSignature;
        runtimeStatisticInformation = new RuntimeStatisticInformation(timestamp);
    }

    public long getLoggingTimestamp() {
        return timestamp;
    }

    public long getTraceId() {
        return traceId;
    }

    public int getOrderIndex() {
        return orderIndex;
    }

    public String getOperationSignature() {
        return operationSignature;
    }

    public RuntimeStatisticInformation getRuntime() {
        return runtimeStatisticInformation;
    }
}
